#ifndef ARCHIVABLE_ENTRY_H
#define ARCHIVABLE_ENTRY_H

#ifndef F_ARCH_CAPSULE_H
#include <FArchCapsule.h>
#endif

#ifndef F_CAPSULE_BUFFER_H
#include "FCapsuleBuffer.h"
#endif

#ifndef EDITOR_DESC_H
#include "EditorDesc.h"
#endif

class ArchivableEntry : public BListItem , public EditorDesc {
public:
	ArchivableEntry(const char* setname, object_ref	setref, FCapsuleBuffer*	setbuffer);
	virtual ~ArchivableEntry();
	virtual	void		DrawItem(BView *owner, BRect bounds, bool complete = false);
//	virtual status_t	Archive(BMessage*	data, bool deep);
	bool				UpdateData();
	
	object_ref			Ref();
	const char*			Name();
	BMessage*			ArchData();
	
	virtual status_t	Invoke();
	virtual	void		EditorClosed();
	virtual void		SelfEditorClose();
private:
	char		name[256];
	object_ref	ref;
	bool is_data_to_change;
	
//	BWindow*		editor;
	FCapsuleBuffer*	arch_list;
};
#endif