/****************************************************/
/*		FCapsuleBuffer.h							*/
/****************************************************/
/*		Copyright 	Florian Ballenegger				*/
/*					Florisoft *not*inc.				*/
/*		Juillet 1997 - 10 juillet 1997						*/
/****************************************************/
/*	The FCapsuleBuffer is a concrete class that allow to	*/
/*	modifiy BArchivable objects information in a buffered way .	*/
/****************************************************/
/*	MADE IN SWITZERLAND / Produit suisse				*/
/****************************************************/

#ifndef F_CAPSULE_BUFFER_H
#define F_CAPSULE_BUFFER_H

#ifndef  F_ARCH_CAPSULE_H
#include <FArchCapsule.h>
#endif

#define F_CAPSULE_MSGWHAT	'Caps'
#define F_TOC_ENTRY_NAME	"F_TOCOfTheCapsule"
#define F_OBJECT_ENTRY_NAME	"F_ArchivableObjectOfCapsule"

class FCapsuleBuffer : public FArchCapsule, public BListView{
public:
	FCapsuleBuffer(BRect	frame, FArchCapsule* bufferof);
	~FCapsuleBuffer();
	
	BMessage*	EditFrame(object_ref ref);
	
	virtual	status_t	OpenTheCapsule();
	virtual	status_t	FreeTheCapsule();
	
			void	SaveModifications();
			void	UpdateData();
	virtual	status_t	WriteFrame(BMessage*	data, object_entry* entry) ;
	virtual	status_t	ReadFrame(BMessage*	data, object_entry* entry) ;
	virtual	status_t	WriteControlData(BMessage* IOmsg);
	virtual	status_t	ReadControlData(BMessage* IOmsg);
	
	virtual	BArchivable*	InstantiateObject(BMessage* data);
	
	virtual void		MessageReceived(BMessage*	msg);
	
private:
	FArchCapsule*	buffered;
	char			im_path[1024];
};

#endif