/******************************************************************************
**
**	File:		MessageField.h
**
**	Description:	MessageField listitem (for use with the BListView class).
**
**	Copyright 1997-97, Florisoft Incorporated
**
*******************************************************************************/
#ifndef MESSAGE_FIELD_H
#define MESSAGE_FIELD_H

#define LEFT_COUNT	13
#define LEFT_NAME	25
#define LEFT_TYPE	100
#define LEFT_INDEX	140
#define LEFT_SIZE	180
#define LEFT_DATA	240

#define BOTTOM_MARGE	2

#ifndef SELECTABLE_FIELD
#include "SelectableField.h"
#endif

class MessageField : public SelectableField  {
public:
					MessageField(const char* setname, int32 setindex, type_code settype, BMessage*	edit, bool newfield = false);
					MessageField(BMessage* data);
virtual				~MessageField();

virtual	void		DrawItem(BView *owner,
							BRect bounds,
							bool complete = false);
virtual	void		DrawShortData(BView *owner, BRect bounds);
virtual	void		AddNewDefaultData();
virtual	void		Remove();
// virtual	void		Update(BView *owner, const BFont *font);

virtual	void		Selected(BListView*	owner, BRect frame);
virtual	void		Unselected(BListView*	owner);
	void			ReorderIndex(const char* forname, const BMessage*	forMessage, int32 indexinout, bool remove);
virtual void		UpdateData();
	const char*		Name();
	const BMessage*	Message() {return edit_msg;}
	int32			Index();
	type_code		Type();
protected:
	char	name[128];
	int32	index;
	type_code	type;
	BMessage*	edit_msg;
};

#endif