#ifndef PROP_EDITOR_DESC_H
#define PROP_EDITOR_DESC_H

#ifndef F_GEN_TABLE_LIST_H
#include <FGenTableList.h>
#endif

#define I_SELECT_OBJECT		'selO'
#define I_REMOVE_OBJECT		'rmvO'

struct proped_entry {
	BWindow*		editor;
	BArchivable*	target;
};

class PropEditorDesc : private BLocker  {
public:
	PropEditorDesc(BWindow* ed, BArchivable* targ);
	PropEditorDesc(PropEditorDesc* otherdesc);
	virtual ~PropEditorDesc();
	
	virtual bool		SetUpData();
	virtual status_t	RunPropEditorFor(BArchivable* target, const char* title = NULL, BRect* edframe = NULL);
			status_t	QuitEditors();
	virtual	void		PropEditorClose(BWindow*	which);
			bool		IsEditing(BArchivable* which);
			
			void		CommitChange(BArchivable* modified);
			void		RemoveObject(BArchivable* toremove, BMessage* addto = NULL);
	proped_entry*	PropEdAt(long i) {return (proped_entry*) editors_list.ItemAt(i);}
	BArchivable*	MainTarget() {return main_target;}
	BWindow*		MainEditor() {return main_editor;}
			bool	SafeMode() {return safe_removing;}
					SetSafeMode(bool safe);
protected:
	FGenTableList	editors_list;
	BArchivable*	main_target;
	BWindow			*main_editor;
private:
	//status_t		SearchPartialEditor(BList* fillin, BArchivable* fortarget);
	static	long 	FindTarget(void* item, void* fTarget);
	static	long 	FindEditor(void* item, void* fEditor);
	static	long 	CmpPropEdEntry(void* item_left, void* item_right);
	
			bool	safe_removing;
};
#endif