#ifndef RESOURCE_ENTRY_H
#define RESOURCE_ENTRY_H

#ifndef EDITOR_DESC_H
#include "EditorDesc.h"
#endif

#define RES_MARGE_BOTTOM 2
#define	RES_LEFT_TYPE	10
#define RES_LEFT_ID		55
#define RES_LEFT_NAME	95
#define	RES_LEFT_SIZE	230

#define RES_NAME_MAX_LENGTH 256
#include <FColumnList.h>

class ResourceEntry : public BListItem , public EditorDesc {
public:
	ResourceEntry(type_code ty, int32 setid, const char* setname, size_t	si, BResources*	setres, FColumnList* cont);
	virtual ~ResourceEntry();
	virtual	void		DrawItem(BView *owner, BRect bounds, bool complete = false);
	void				LinkToResFile(BResources* setres);
	void				SetNewData(void*	newdata, size_t	length);
	void				ReadData(void*	buffer, size_t	buffer_length);
	void*				GetData(size_t* sizehold);
	void				WriteData();
	void				RemoveResource();

	void				Revert();
	size_t				Size();
	const char*			Name();
	type_code			Type();
	int32				Id() {return id;}
	
	virtual status_t	Invoke(edit_form form = F_BEST_EDIT_FORM);
	virtual void		Clean();
			void		EditorClosed();
			void		DetachEditors();
	virtual bool		UpdateData();
			bool		IsDataToChange() {return is_data_to_change;}
private:
	type_code	type;
	int32		id;
	char		name[RES_NAME_MAX_LENGTH];
	size_t		size;
	void*		data;
	bool is_data_to_change;
	BResources*	res;
	BWindow*	res_editor;
	FColumnList*	container;
};
#endif