#ifndef WINDOW_EDIT_FILTER_H
#define WINDOW_EDIT_FILTER_H

#ifndef PROP_EDITOR_DESC_H
#include "PropEditorDesc.h"
#endif

class WindowEditFilter : public BMessageFilter {
public:
	WindowEditFilter(BWindow* settarget);
	~WindowEditFilter();
	virtual	filter_result		Filter(BMessage *message, BHandler **target);
	
	filter_result	FilterClick(BMessage* msg, BHandler* target);
	filter_result	FilterDraw(BMessage* msg);
	filter_result	FilterKeyDown(BMessage* msg, BHandler* target);
	filter_result	ClickInView(BView* v, BPoint initial, BMessage* msg);
	status_t		AddArchive(BMessage*, BHandler *target);
	void	FocusDrop(BMessage* msg);
	void	InvalidateSelection();
	void	AddToSelection(BView* v);
	void	ToggleToSelection(BView* v);
	void	SetSelection(BView* v);
	void	MakeSelectionEmpty();
	void	ReDrawSelection();
	void	ReDraw(BView* v);
	void	PostReDraw(BView* v = NULL);
	
	void	MoveSelection(float dx, float dy);
	void	DeleteSelection();
	void	DeleteObject(BArchivable* obj);
	static	long update_func(void*arg);
	void	UpdateJob();
	bool	Undo();
private:
	static 	long grow_thread(void* arg);
	void	GrowView(BView* v, BPoint initial);
	bool	growing;
	void	DragView(BView* v, BPoint initial, BMessage* clikMsg);
	void	CommitSelectionChange();
	bool	IsClickInSelection(BPoint screenClick, BView** realhandler);
	void	AlignSelection(BMessage* msg);
	BWindow* edited;
	BView*	anc_focus, *cur_drag;
	BList	selection;
	volatile bool quiting;
	thread_id update_thread;
	
	PropEditorDesc	prop_editors;
	bool	test_mode;
	BMessage* undo_buffer;
};

#endif